Create or Update Preference Category
Use this API to set preference categories to be used in workflow or to show on user preference page.
curl -X POST "https://management-api.suprsend.com/v1/{workspace}/preference_category/?commit=false" \
--header "Authorization: ServiceToken {token}" \
--header "Content-Type: application/json" \
--data '{
"root_categories": [
{
"root_category": "system"
},
{
"root_category": "transactional",
"sections": [
{
"name": "Task Updates",
"categories": [
{
"category": "tagged-to-me",
"name": "Tagged to Me",
"description": "Status Update or mentions on tasks assigned by me or tagged to me",
"default_preference": "opt_in",
"digest_schedule": {
"enabled": true,
"options": [
{
"id": "instant",
"label": "Instant",
"frequency": "instantly",
"is_default": true
},
{
"id": "daily-digest",
"label": "Daily at 9:00 AM",
"frequency": "daily",
"interval": 1,
"time": { "edit_policy": "editable", "default_value": "09:00" },
"is_default": false
}
]
},
"properties": [
{
"key": "threshold",
"label": "Threshold",
"value_type": "integer",
"is_optional": false,
"default_value": 10,
"edit_policy": "editable"
}
]
}
]
}
]
},
{
"root_category": "promotional",
"sections": [
{
"name": "Product Updates",
"categories": [
{
"category": "newsletter",
"name": "Newsletter",
"default_preference": "opt_out",
"digest_schedule": null,
"properties": null
}
]
}
]
}
]
}'import requests
url = "https://management-api.suprsend.com/v1/{workspace}/preference_category/"
payload = { "root_categories": [{ "sections": [
{
"name": "<string>",
"description": "<string>",
"tags": ["<string>"],
"categories": [
{
"category": "<string>",
"name": "<string>",
"description": "<string>",
"default_mandatory_channels": [],
"default_opt_in_channels": [],
"tags": ["<string>"],
"digest_schedule": {
"enabled": True,
"options": [
{
"id": "<string>",
"label": "<string>",
"interval": 2,
"time": { "default_value": "00:00" },
"weekdays": { "default_value": [] },
"monthdays": { "default_value": [{ "pos": 123 }] },
"dtstart": { "default_value": "2026-06-20T00:00:00Z" },
"is_default": True
}
]
},
"properties": [
{
"key": "<string>",
"label": "<string>",
"is_optional": False,
"choices": [
{
"value": "<string>",
"label": "<string>"
}
],
"default_value": "<unknown>",
"dynamic_choices_key": "<string>"
}
]
}
]
}
] }] }
headers = {
"ServiceToken <token>": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'ServiceToken <token>': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
root_categories: [
{
sections: [
{
name: '<string>',
description: '<string>',
tags: ['<string>'],
categories: [
{
category: '<string>',
name: '<string>',
description: '<string>',
default_mandatory_channels: [],
default_opt_in_channels: [],
tags: ['<string>'],
digest_schedule: {
enabled: true,
options: [
{
id: '<string>',
label: '<string>',
interval: 2,
time: {default_value: '00:00'},
weekdays: {default_value: []},
monthdays: {default_value: [{pos: 123}]},
dtstart: {default_value: '2026-06-20T00:00:00Z'},
is_default: true
}
]
},
properties: [
{
key: '<string>',
label: '<string>',
is_optional: false,
choices: [{value: '<string>', label: '<string>'}],
default_value: '<unknown>',
dynamic_choices_key: '<string>'
}
]
}
]
}
]
}
]
})
};
fetch('https://management-api.suprsend.com/v1/{workspace}/preference_category/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"$schema": "https://schema.suprsend.com/preference_category/v1/schema.json",
"root_categories": [
{
"root_category": "system",
"sections": []
},
{
"root_category": "transactional",
"sections": [
{
"name": "Task Updates",
"description": null,
"tags": null,
"categories": [
{
"category": "tagged-to-me",
"name": "Tagged to Me",
"description": "Status Update or mentions on tasks assigned by me or tagged to me",
"default_preference": "opt_in",
"default_mandatory_channels": null,
"default_opt_in_channels": null,
"tags": null,
"digest_schedule": {
"enabled": true,
"options": [
{
"id": "instant",
"label": "Instant",
"frequency": "instantly",
"is_default": true
},
{
"id": "daily-digest",
"label": "Daily at 9:00 AM",
"frequency": "daily",
"interval": 1,
"time": {
"edit_policy": "editable",
"default_value": "09:00"
},
"is_default": false
}
]
},
"properties": [
{
"key": "priority",
"label": "Minimum priority",
"value_type": "string_choice",
"is_optional": false,
"choices": [
{
"value": "low",
"label": "Low"
},
{
"value": "medium",
"label": "Medium"
},
{
"value": "high",
"label": "High"
}
],
"default_value": "high",
"edit_policy": "editable"
}
]
}
]
}
]
},
{
"root_category": "promotional",
"sections": [
{
"name": "Product Updates",
"description": null,
"tags": null,
"categories": [
{
"category": "newsletter",
"name": "Newsletter",
"description": null,
"default_preference": "opt_out",
"default_mandatory_channels": null,
"default_opt_in_channels": null,
"tags": null,
"digest_schedule": null,
"properties": null
}
]
}
]
}
],
"version_no": 3,
"status": "draft",
"commit_message": null,
"committed_at": null,
"validation_result": {
"is_valid": true
}
}{
"code": 401,
"message": "ServiceToken not found"
}{
"code": 404,
"message": "workspace not found for slug/uid: workspace"
}You can read more about preference categories here.
Note:
Changes will only be pushed if "validation_result":{"is_valid":true} in the response. General reasons for validation failure are:
- There are multiple categories with the same slug
- Some subcategories have been deleted in this version, on which active workflows are configured
- You’ve not passed all three categories in the request body - system, transactional, promotional
Authorizations
You can get Service Token from SuprSend dashboard -> Account Settings -> Service Tokens section.
Path Parameters
Workspace slug (staging, production, etc.)
Query Parameters
Whether to commit changes immediately. Set to true to make changes live, false to save as draft.
Optional commit message describing the changes made. Required when commit=true.
Body
Array of root preference categories. Include all three root categories (system, transactional, promotional) even if empty.
Show child attributes
Show child attributes
Response
Successfully created/updated preference category
JSON schema reference for preference category structure
"https://schema.suprsend.com/preference_category/v1/schema.json"
Array of root preference categories
Show child attributes
Show child attributes
Current status of the preference category
draft, active "draft"
Version number field as an identifier to track the version
3
Commit message describing the changes that were made
null
Timestamp when the changes were committed
null
Result of validating the preference category
Show child attributes
Show child attributes
Was this page helpful?
curl -X POST "https://management-api.suprsend.com/v1/{workspace}/preference_category/?commit=false" \
--header "Authorization: ServiceToken {token}" \
--header "Content-Type: application/json" \
--data '{
"root_categories": [
{
"root_category": "system"
},
{
"root_category": "transactional",
"sections": [
{
"name": "Task Updates",
"categories": [
{
"category": "tagged-to-me",
"name": "Tagged to Me",
"description": "Status Update or mentions on tasks assigned by me or tagged to me",
"default_preference": "opt_in",
"digest_schedule": {
"enabled": true,
"options": [
{
"id": "instant",
"label": "Instant",
"frequency": "instantly",
"is_default": true
},
{
"id": "daily-digest",
"label": "Daily at 9:00 AM",
"frequency": "daily",
"interval": 1,
"time": { "edit_policy": "editable", "default_value": "09:00" },
"is_default": false
}
]
},
"properties": [
{
"key": "threshold",
"label": "Threshold",
"value_type": "integer",
"is_optional": false,
"default_value": 10,
"edit_policy": "editable"
}
]
}
]
}
]
},
{
"root_category": "promotional",
"sections": [
{
"name": "Product Updates",
"categories": [
{
"category": "newsletter",
"name": "Newsletter",
"default_preference": "opt_out",
"digest_schedule": null,
"properties": null
}
]
}
]
}
]
}'import requests
url = "https://management-api.suprsend.com/v1/{workspace}/preference_category/"
payload = { "root_categories": [{ "sections": [
{
"name": "<string>",
"description": "<string>",
"tags": ["<string>"],
"categories": [
{
"category": "<string>",
"name": "<string>",
"description": "<string>",
"default_mandatory_channels": [],
"default_opt_in_channels": [],
"tags": ["<string>"],
"digest_schedule": {
"enabled": True,
"options": [
{
"id": "<string>",
"label": "<string>",
"interval": 2,
"time": { "default_value": "00:00" },
"weekdays": { "default_value": [] },
"monthdays": { "default_value": [{ "pos": 123 }] },
"dtstart": { "default_value": "2026-06-20T00:00:00Z" },
"is_default": True
}
]
},
"properties": [
{
"key": "<string>",
"label": "<string>",
"is_optional": False,
"choices": [
{
"value": "<string>",
"label": "<string>"
}
],
"default_value": "<unknown>",
"dynamic_choices_key": "<string>"
}
]
}
]
}
] }] }
headers = {
"ServiceToken <token>": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'ServiceToken <token>': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
root_categories: [
{
sections: [
{
name: '<string>',
description: '<string>',
tags: ['<string>'],
categories: [
{
category: '<string>',
name: '<string>',
description: '<string>',
default_mandatory_channels: [],
default_opt_in_channels: [],
tags: ['<string>'],
digest_schedule: {
enabled: true,
options: [
{
id: '<string>',
label: '<string>',
interval: 2,
time: {default_value: '00:00'},
weekdays: {default_value: []},
monthdays: {default_value: [{pos: 123}]},
dtstart: {default_value: '2026-06-20T00:00:00Z'},
is_default: true
}
]
},
properties: [
{
key: '<string>',
label: '<string>',
is_optional: false,
choices: [{value: '<string>', label: '<string>'}],
default_value: '<unknown>',
dynamic_choices_key: '<string>'
}
]
}
]
}
]
}
]
})
};
fetch('https://management-api.suprsend.com/v1/{workspace}/preference_category/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"$schema": "https://schema.suprsend.com/preference_category/v1/schema.json",
"root_categories": [
{
"root_category": "system",
"sections": []
},
{
"root_category": "transactional",
"sections": [
{
"name": "Task Updates",
"description": null,
"tags": null,
"categories": [
{
"category": "tagged-to-me",
"name": "Tagged to Me",
"description": "Status Update or mentions on tasks assigned by me or tagged to me",
"default_preference": "opt_in",
"default_mandatory_channels": null,
"default_opt_in_channels": null,
"tags": null,
"digest_schedule": {
"enabled": true,
"options": [
{
"id": "instant",
"label": "Instant",
"frequency": "instantly",
"is_default": true
},
{
"id": "daily-digest",
"label": "Daily at 9:00 AM",
"frequency": "daily",
"interval": 1,
"time": {
"edit_policy": "editable",
"default_value": "09:00"
},
"is_default": false
}
]
},
"properties": [
{
"key": "priority",
"label": "Minimum priority",
"value_type": "string_choice",
"is_optional": false,
"choices": [
{
"value": "low",
"label": "Low"
},
{
"value": "medium",
"label": "Medium"
},
{
"value": "high",
"label": "High"
}
],
"default_value": "high",
"edit_policy": "editable"
}
]
}
]
}
]
},
{
"root_category": "promotional",
"sections": [
{
"name": "Product Updates",
"description": null,
"tags": null,
"categories": [
{
"category": "newsletter",
"name": "Newsletter",
"description": null,
"default_preference": "opt_out",
"default_mandatory_channels": null,
"default_opt_in_channels": null,
"tags": null,
"digest_schedule": null,
"properties": null
}
]
}
]
}
],
"version_no": 3,
"status": "draft",
"commit_message": null,
"committed_at": null,
"validation_result": {
"is_valid": true
}
}{
"code": 401,
"message": "ServiceToken not found"
}{
"code": 404,
"message": "workspace not found for slug/uid: workspace"
}